    /*!
     * Ext JS Library 3.3.1
     * Copyright(c) 2006-2010 Sencha Inc.
     * licensing@sencha.com
     * http://www.sencha.com/license
     */
    /**
     * @class Ext.CompositeElement
     * @extends Ext.CompositeElementLite
     * This class encapsulates a collection of DOM elements, providing methods to filter
     * members, or to perform collective actions upon the whole set.
     * Although they are not listed, this class supports all of the methods of {@link Ext.Element} and
     * {@link Ext.Fx}. The methods from these classes will be performed on all the elements in this collection.
     * All methods return this and can be chained.
     * Usage:

    var els = Ext.select("#some-el div.some-class", true);
    // or select directly from an existing element
    var el = Ext.get('some-el');
    el.select('div.some-class', true);

    els.setWidth(100); // all elements become 100 width
    els.hide(true); // all elements fade out and hide
    // or
    els.setWidth(100).hide(true);

     */
    Ext.CompositeElement = Ext.extend(Ext.CompositeElementLite, {

        constructor : function(els, root){
            this.elements = [];
            this.add(els, root);
        },

        // private
        getElement : function(el){
            // In this case just return it, since we already have a reference to it
            return el;
        },

        // private
        transformElement : function(el){
            return Ext.get(el);
        }

        /**
        * Adds elements to this composite.
        * @param {String/Array} els A string CSS selector, an array of elements or an element
        * @return {CompositeElement} this
        */

        /**
         * Returns the Element object at the specified index
         * @param {Number} index
         * @return {Ext.Element}
         */

        /**
         * Iterates each element in this composite
         * calling the supplied function using {@link Ext#each}.
         * @param {Function} fn The function to be called with each
         * element. If the supplied function returns false,
         * iteration stops. This function is called with the following arguments:
         *
         * element : Ext.ElementThe element at the current index
         * in the composite
         * composite : Object This composite.
         * index : Number The current index within the composite
         *
         * @param {Object} scope (optional) The scope (<this reference) in which the specified function is executed.
         * Defaults to the element at the current index
         * within the composite.
         * @return {CompositeElement} this
         */
    });

    /**
     * Selects elements based on the passed CSS selector to enable {@link Ext.Element Element} methods
     * to be applied to many related elements in one statement through the returned {@link Ext.CompositeElement CompositeElement} or
     * {@link Ext.CompositeElementLite CompositeElementLite} object.
     * @param {String/Array} selector The CSS selector or an array of elements
     * @param {Boolean} unique (optional) true to create a unique Ext.Element for each element (defaults to a shared flyweight object)
     * @param {HTMLElement/String} root (optional) The root element of the query or id of the root
     * @return {CompositeElementLite/CompositeElement}
     * @member Ext.Element
     * @method select
     */
    Ext.Element.select = function(selector, unique, root){
        var els;
        if(typeof selector == "string"){
            els = Ext.Element.selectorFunction(selector, root);
        }else if(selector.length !== undefined){
            els = selector;
        }else{
            throw "Invalid selector";
        }

        return (unique === true) ? new Ext.CompositeElement(els) : new Ext.CompositeElementLite(els);
    };

    /**
     * Selects elements based on the passed CSS selector to enable {@link Ext.Element Element} methods
     * to be applied to many related elements in one statement through the returned {@link Ext.CompositeElement CompositeElement} or
     * {@link Ext.CompositeElementLite CompositeElementLite} object.
     * @param {String/Array} selector The CSS selector or an array of elements
     * @param {Boolean} unique (optional) true to create a unique Ext.Element for each element (defaults to a shared flyweight object)
     * @param {HTMLElement/String} root (optional) The root element of the query or id of the root
     * @return {CompositeElementLite/CompositeElement}
     * @member Ext
     * @method select
     */
    Ext.select = Ext.Element.select;